Index: src/Actions/Makefile.am
===================================================================
--- src/Actions/Makefile.am	(revision 07a47e0c167bba50906b5cc3e9289ec6e7f1c6db)
+++ src/Actions/Makefile.am	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
@@ -229,15 +229,15 @@
 PARSERACTIONSOURCE = \
   Actions/ParserAction/ParseTremoloPotentialsAction.cpp \
-  Actions/ParserAction/SetMpqcParametersAction.cpp \
+  Actions/ParserAction/SetParserParametersAction.cpp \
   Actions/ParserAction/SetOutputFormatsAction.cpp \
   Actions/ParserAction/SetTremoloAtomdataAction.cpp
 PARSERACTIONHEADER = \
   Actions/ParserAction/ParseTremoloPotentialsAction.hpp \
-  Actions/ParserAction/SetMpqcParametersAction.hpp \
+  Actions/ParserAction/SetParserParametersAction.hpp \
   Actions/ParserAction/SetOutputFormatsAction.hpp \
   Actions/ParserAction/SetTremoloAtomdataAction.hpp
 PARSERACTIONDEFS = \
   Actions/ParserAction/ParseTremoloPotentialsAction.def \
-  Actions/ParserAction/SetMpqcParametersAction.def \
+  Actions/ParserAction/SetParserParametersAction.def \
   Actions/ParserAction/SetOutputFormatsAction.def \
   Actions/ParserAction/SetTremoloAtomdataAction.def
Index: c/Actions/ParserAction/SetMpqcParametersAction.cpp
===================================================================
--- src/Actions/ParserAction/SetMpqcParametersAction.cpp	(revision 07a47e0c167bba50906b5cc3e9289ec6e7f1c6db)
+++ 	(revision )
@@ -1,79 +1,0 @@
-/*
- * Project: MoleCuilder
- * Description: creates and alters molecular systems
- * Copyright (C)  2010 University of Bonn. All rights reserved.
- * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
- */
-
-/*
- * SetMpqcParametersAction.cpp
- *
- *  Created on: May 8, 2010
- *      Author: heber
- */
-
-// include config.h
-#ifdef HAVE_CONFIG_H
-#include <config.h>
-#endif
-
-#include "CodePatterns/MemDebug.hpp"
-
-#include "CodePatterns/Log.hpp"
-#include "CodePatterns/Verbose.hpp"
-#include "Parser/FormatParserStorage.hpp"
-#include "Parser/MpqcParser.hpp"
-#include "Parser/MpqcParser_Parameters.hpp"
-
-#include <iostream>
-#include <string>
-
-#include "SetMpqcParametersAction.hpp"
-
-using namespace MoleCuilder;
-
-// and construct the stuff
-#include "SetMpqcParametersAction.def"
-#include "Action_impl_pre.hpp"
-/** =========== define the function ====================== */
-Action::state_ptr ParserSetMpqcParametersAction::performCall() {
-  MpqcParser_Parameters &parser = FormatParserStorage::getInstance().getParser<mpqc>().getParams();
-
-  std::stringstream oldparamstream;
-  oldparamstream << parser;
-  // obtain information
-  getParametersfromValueStorage();
-  std::stringstream newparamstream(params.newparams);
-  newparamstream >> parser;
-
-  return Action::state_ptr(new ParserSetMpqcParametersState(oldparamstream.str(), params));
-}
-
-Action::state_ptr ParserSetMpqcParametersAction::performUndo(Action::state_ptr _state) {
-  ParserSetMpqcParametersState *state = assert_cast<ParserSetMpqcParametersState*>(_state.get());
-
-  MpqcParser_Parameters &parser = FormatParserStorage::getInstance().getParser<mpqc>().getParams();
-  std::stringstream oldparamstream(state->oldparams);
-  oldparamstream >> parser;
-
-  return Action::state_ptr(_state);
-}
-
-Action::state_ptr ParserSetMpqcParametersAction::performRedo(Action::state_ptr _state){
-  ParserSetMpqcParametersState *state = assert_cast<ParserSetMpqcParametersState*>(_state.get());
-
-  MpqcParser_Parameters &parser = FormatParserStorage::getInstance().getParser<mpqc>().getParams();
-  std::stringstream newparamstream(state->params.newparams);
-  newparamstream >> parser;
-
-  return Action::state_ptr(_state);
-}
-
-bool ParserSetMpqcParametersAction::canUndo() {
-  return true;
-}
-
-bool ParserSetMpqcParametersAction::shouldUndo() {
-  return true;
-}
-/** =========== end of function ====================== */
Index: c/Actions/ParserAction/SetMpqcParametersAction.def
===================================================================
--- src/Actions/ParserAction/SetMpqcParametersAction.def	(revision 07a47e0c167bba50906b5cc3e9289ec6e7f1c6db)
+++ 	(revision )
@@ -1,33 +1,0 @@
-/*
- * SetMpqcParametersAction.def
- *
- *  Created on: Aug 26, 2010
- *      Author: heber
- */
-
-// all includes and forward declarations necessary for non-integral types below
-
-
-// i.e. there is an integer with variable name Z that can be found in
-// ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
-#define paramtypes (std::string)
-#define paramtokens ("set-mpqc-parameters")
-#define paramdescriptions ("parameter (key = value;) assignment for MPQC")
-#undef paramdefaults
-#define paramreferences (newparams)
-
-#define statetypes (std::string)
-#define statereferences (oldparams)
-
-// some defines for all the names, you may use ACTION, STATE and PARAMS
-#define CATEGORY Parser
-#define MENUNAME "parser"
-#define MENUPOSITION 11
-#define ACTIONNAME SetMpqcParameters
-#define TOKEN "set-mpqc-parameters"
-
-
-// finally the information stored in the ActionTrait specialization
-#define DESCRIPTION "set the parameters for MPQC"
-#define SHORTFORM "M"
Index: c/Actions/ParserAction/SetMpqcParametersAction.hpp
===================================================================
--- src/Actions/ParserAction/SetMpqcParametersAction.hpp	(revision 07a47e0c167bba50906b5cc3e9289ec6e7f1c6db)
+++ 	(revision )
@@ -1,22 +1,0 @@
-/*
- * SetMpqcParametersAction.hpp
- *
- *  Created on: May 8, 2010
- *      Author: heber
- */
-
-#ifndef SETMPQCPARAMETERSACTION_HPP_
-#define SETMPQCPARAMETERSACTION_HPP_
-
-// include config.h
-#ifdef HAVE_CONFIG_H
-#include <config.h>
-#endif
-
-
-#include "Actions/Action.hpp"
-
-#include "SetMpqcParametersAction.def"
-#include "Action_impl_header.hpp"
-
-#endif /* SETMPQCPARAMETERSACTION_HPP_ */
Index: src/Actions/ParserAction/SetParserParametersAction.cpp
===================================================================
--- src/Actions/ParserAction/SetParserParametersAction.cpp	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
+++ src/Actions/ParserAction/SetParserParametersAction.cpp	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
@@ -0,0 +1,90 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * SetParserParametersAction.cpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "CodePatterns/Log.hpp"
+#include "CodePatterns/Verbose.hpp"
+#include "Parser/FormatParserStorage.hpp"
+#include "Parser/MpqcParser.hpp"
+#include "Parser/MpqcParser_Parameters.hpp"
+#include "Actions/ValueStorage.hpp"
+
+#include <iostream>
+#include <string>
+
+#include "SetParserParametersAction.hpp"
+
+using namespace MoleCuilder;
+
+// and construct the stuff
+#include "SetParserParametersAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr ParserSetParserParametersAction::performCall() {
+  // get parameters
+  getParametersfromValueStorage();
+
+  // get parser
+  ParserTypes type = FormatParserStorage::getInstance().getTypeFromName(params.parsername);
+  FormatParser_Parameters *parameters = FormatParserStorage::getInstance().get(type).parameters;
+  ASSERT(parameters != NULL,
+      "ParserSetParserParametersAction::performCall() - parameters of parser is NULL.");
+
+  // obtain undo state
+  std::stringstream oldparamstream;
+  oldparamstream << *parameters;
+
+  // obtain information
+  std::stringstream newparamstream(params.newparams);
+  newparamstream >> *parameters;
+
+  return Action::state_ptr(new ParserSetParserParametersState(oldparamstream.str(), params));
+}
+
+Action::state_ptr ParserSetParserParametersAction::performUndo(Action::state_ptr _state) {
+  ParserSetParserParametersState *state = assert_cast<ParserSetParserParametersState*>(_state.get());
+
+  ParserTypes type = FormatParserStorage::getInstance().getTypeFromName(state->params.parsername);
+  FormatParser_Parameters *parser = FormatParserStorage::getInstance().get(type).parameters;
+  std::stringstream oldparamstream(state->oldparams);
+  oldparamstream >> *parser;
+
+  return Action::state_ptr(_state);
+}
+
+Action::state_ptr ParserSetParserParametersAction::performRedo(Action::state_ptr _state){
+  ParserSetParserParametersState *state = assert_cast<ParserSetParserParametersState*>(_state.get());
+
+  ParserTypes type = FormatParserStorage::getInstance().getTypeFromName(state->params.parsername);
+  FormatParser_Parameters *parser = FormatParserStorage::getInstance().get(type).parameters;
+  std::stringstream newparamstream(state->params.newparams);
+  newparamstream >> *parser;
+
+  return Action::state_ptr(_state);
+}
+
+bool ParserSetParserParametersAction::canUndo() {
+  return true;
+}
+
+bool ParserSetParserParametersAction::shouldUndo() {
+  return true;
+}
+/** =========== end of function ====================== */
Index: src/Actions/ParserAction/SetParserParametersAction.def
===================================================================
--- src/Actions/ParserAction/SetParserParametersAction.def	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
+++ src/Actions/ParserAction/SetParserParametersAction.def	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
@@ -0,0 +1,33 @@
+/*
+ * SetParserParametersAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+#define paramtypes (std::string)(std::string)
+#define paramtokens ("set-parser-parameters")("parser-parameters")
+#define paramdescriptions ("name of the parser to change")("parameter (key = value;)")
+#define paramdefaults (NODEFAULT)(NODEFAULT)
+#define paramreferences (parsername)(newparams)
+
+#define statetypes (std::string)
+#define statereferences (oldparams)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Parser
+#define MENUNAME "parser"
+#define MENUPOSITION 11
+#define ACTIONNAME SetParserParameters
+#define TOKEN "set-parser-parameters"
+
+
+// finally the information stored in the ActionTrait specialization
+#define DESCRIPTION "set the parameters for a given parser"
+#define SHORTFORM "M"
Index: src/Actions/ParserAction/SetParserParametersAction.hpp
===================================================================
--- src/Actions/ParserAction/SetParserParametersAction.hpp	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
+++ src/Actions/ParserAction/SetParserParametersAction.hpp	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
@@ -0,0 +1,22 @@
+/*
+ * SetParserParametersAction.hpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#ifndef SETPARSERPARAMETERSACTION_HPP_
+#define SETPARSERPARAMETERSACTION_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include "Actions/Action.hpp"
+
+#include "SetParserParametersAction.def"
+#include "Action_impl_header.hpp"
+
+#endif /* SETPARSERPARAMETERSACTION_HPP_ */
Index: src/Parser/FormatParser_Parameters.cpp
===================================================================
--- src/Parser/FormatParser_Parameters.cpp	(revision 07a47e0c167bba50906b5cc3e9289ec6e7f1c6db)
+++ src/Parser/FormatParser_Parameters.cpp	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
@@ -129,6 +129,6 @@
       iter != params.storage->getEndIter();
       ++iter)
-    output << iter->first
-           <<  "=" << iter->second->get() << ";";
+    if (!iter->second->get().empty())
+      output << iter->first <<  "=" << iter->second->get() << ";";
   ost << output.str();
   return ost;
@@ -160,16 +160,16 @@
     if (paramtokens.begin() != paramtokens.end()) {
       tokenizer::iterator tok_paramiter = paramtokens.begin();
+      ASSERT(tok_paramiter != paramtokens.end(),
+          "operator<< on FormatParser_Parameters - missing value before ' =' in token "+*tok_iter+"!");
       tokenizer::iterator tok_valueiter = tok_paramiter;
       tokenizer::iterator tok_checkiter = ++tok_valueiter;
-      ++tok_checkiter;
-      LOG(3, "INFO: key is '" << *tok_paramiter << "', value is '" << *tok_valueiter << "'.");
-      // TODO: throw exception instead of ASSERT
-      ASSERT(tok_paramiter != paramtokens.end(),
-          "operator<< on FormatParser_Parameters - missing value before ' =' in token "+*tok_iter+"!");
       ASSERT(tok_valueiter != paramtokens.end(),
           "operator<< on FormatParser_Parameters - missing value after ' =' in token "+*tok_iter+"!");
+      ++tok_checkiter;
       ASSERT(tok_checkiter == paramtokens.end(),
           "operator<< on FormatParser_Parameters - still more tokens after ' =' in token "+*tok_iter+":"
           +*tok_checkiter+"!");
+      LOG(3, "INFO: key is '" << *tok_paramiter << "', value is '" << *tok_valueiter << "'.");
+      // TODO: throw exception instead of ASSERT
       std::string key(*tok_paramiter);
       std::string value(*tok_valueiter);
Index: tests/regression/Makefile.am
===================================================================
--- tests/regression/Makefile.am	(revision 07a47e0c167bba50906b5cc3e9289ec6e7f1c6db)
+++ tests/regression/Makefile.am	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
@@ -90,8 +90,4 @@
 	$(srcdir)/Parser/Mpqc/testsuite-parser-mpqc-load.at \
 	$(srcdir)/Parser/Mpqc/testsuite-parser-mpqc-save.at \
-	$(srcdir)/Parser/Mpqc-SetParameters/testsuite-parser-mpqc-set-parameters.at \
-	$(srcdir)/Parser/Mpqc-SetParameters/testsuite-parser-mpqc-set-parameters-basis.at \
-	$(srcdir)/Parser/Mpqc-SetParameters/testsuite-parser-mpqc-set-parameters-maxiterations.at \
-	$(srcdir)/Parser/Mpqc-SetParameters/testsuite-parser-mpqc-set-parameters-theory.at \
 	$(srcdir)/Parser/Pcp/testsuite-parser-pcp-empty.at \
 	$(srcdir)/Parser/Pcp/testsuite-parser-pcp-load.at \
@@ -109,4 +105,9 @@
 	$(srcdir)/Parser/Psi3/testsuite-parser-psi3-load.at \
 	$(srcdir)/Parser/Psi3/testsuite-parser-psi3-save.at \
+	$(srcdir)/Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc.at \
+	$(srcdir)/Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc-basis.at \
+	$(srcdir)/Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc-maxiterations.at \
+	$(srcdir)/Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc-theory.at \
+	$(srcdir)/Parser/SetParameters/Psi3/testsuite-parser-set-parameters-psi3-wavefunction.at \
 	$(srcdir)/Parser/Tremolo/testsuite-parser-tremolo-empty.at \
 	$(srcdir)/Parser/Tremolo/testsuite-parser-tremolo-load.at \
Index: sts/regression/Parser/Mpqc-SetParameters/post/testCLHF.in
===================================================================
--- tests/regression/Parser/Mpqc-SetParameters/post/testCLHF.in	(revision 07a47e0c167bba50906b5cc3e9289ec6e7f1c6db)
+++ 	(revision )
@@ -1,23 +1,0 @@
-mpqc: (
-	savestate = no
-	do_gradient = yes
-	mole<CLKS>: (
-		functional<StdDenFunctional>:(name=B3LYP)
-		molecule = $:molecule
-		basis = $:basis
-		maxiter = 499
-		memory = 16000000
-	)
-)
-molecule<Molecule>: (
-	unit = angstrom
-	{ atoms geometry } = {
-		O [ -0.505735	0	0 ]
-		H [ 0.252867	0	0.504284 ]
-		H [ 0.252867	0	-0.504284 ]
-	}
-)
-basis<GaussianBasisSet>: (
-	name = "4-31G"
-	molecule = $:molecule
-)
Index: sts/regression/Parser/Mpqc-SetParameters/pre/test.xyz
===================================================================
--- tests/regression/Parser/Mpqc-SetParameters/pre/test.xyz	(revision 07a47e0c167bba50906b5cc3e9289ec6e7f1c6db)
+++ 	(revision )
@@ -1,3 +1,0 @@
-1
-	Created by molecuilder on Tue Oct  6 18:34:23 2009
-H	10	10	10
Index: sts/regression/Parser/Mpqc-SetParameters/pre/testCLHF.in
===================================================================
--- tests/regression/Parser/Mpqc-SetParameters/pre/testCLHF.in	(revision 07a47e0c167bba50906b5cc3e9289ec6e7f1c6db)
+++ 	(revision )
@@ -1,22 +1,0 @@
-mpqc: (
-	savestate = no
-	do_gradient = yes
-	mole<CLHF>: (
-		molecule = $:molecule
-		basis = $:basis
-		maxiter = 1000
-		memory = 16000000
-	)
-)
-molecule<Molecule>: (
-	unit = angstrom
-	{ atoms geometry } = {
-		O [ -0.505735	0	0 ]
-		H [ 0.252867	0	0.504284 ]
-		H [ 0.252867	0	-0.504284 ]
-	}
-)
-basis<GaussianBasisSet>: (
-	name = "3-21G"
-	molecule = $:molecule
-)
Index: sts/regression/Parser/Mpqc-SetParameters/testsuite-parser-mpqc-set-parameters-basis.at
===================================================================
--- tests/regression/Parser/Mpqc-SetParameters/testsuite-parser-mpqc-set-parameters-basis.at	(revision 07a47e0c167bba50906b5cc3e9289ec6e7f1c6db)
+++ 	(revision )
@@ -1,28 +1,0 @@
-### MPQC basis
-
-AT_SETUP([Parser - MPQC - set basis])
-AT_KEYWORDS([options mpqc set-mpqc-parameters basis])
-
-AT_CHECK([../../molecuilder -i test.conf -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/Mpqc-SetParameters/pre/test.xyz -v 1 --set-mpqc-parameters "basis = 4-31G"], 0, [stdout], [ignore])
-AT_CHECK([fgrep "name = \"4-31G\"" test.in], 0, [ignore], [ignore])
-
-AT_CLEANUP
-
-
-AT_SETUP([Parser - MPQC - set basis with Undo])
-AT_XFAIL_IF([/bin/true])
-AT_KEYWORDS([options mpqc set-mpqc-parameters basis undo])
-
-AT_CHECK([../../molecuilder -i test.conf -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/Mpqc-SetParameters/pre/test.xyz -v 1 --set-mpqc-parameters "basis = 4-31G" --undo], 0, [stdout], [ignore])
-AT_CHECK([fgrep "name = \"4-31G\"" test.in], 0, [ignore], [ignore])
-
-AT_CLEANUP
-
-
-AT_SETUP([Parser - MPQC - set basis with Redo])
-AT_KEYWORDS([options mpqc set-mpqc-parameters basis redo])
-
-AT_CHECK([../../molecuilder -i test.conf -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/Mpqc-SetParameters/pre/test.xyz -v 1 --set-mpqc-parameters "basis = 4-31G" --undo --redo], 0, [stdout], [ignore])
-AT_CHECK([fgrep "name = \"4-31G\"" test.in], 0, [ignore], [ignore])
-
-AT_CLEANUP
Index: sts/regression/Parser/Mpqc-SetParameters/testsuite-parser-mpqc-set-parameters-maxiterations.at
===================================================================
--- tests/regression/Parser/Mpqc-SetParameters/testsuite-parser-mpqc-set-parameters-maxiterations.at	(revision 07a47e0c167bba50906b5cc3e9289ec6e7f1c6db)
+++ 	(revision )
@@ -1,29 +1,0 @@
-### MPQC basis
-
-AT_SETUP([Parser - MPQC - set maxiter])
-AT_KEYWORDS([options mpqc set-mpqc-parameters maxiter])
-
-AT_CHECK([../../molecuilder -i test.conf -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/Mpqc-SetParameters/pre/test.xyz -v 1 --set-mpqc-parameters "maxiter = 499"], 0, [stdout], [ignore])
-AT_CHECK([fgrep "maxiter = 499" test.in], 0, [ignore], [ignore])
-
-AT_CLEANUP
-
-
-AT_SETUP([Parser - MPQC - set maxiter with Undo])
-AT_XFAIL_IF([/bin/true])
-AT_KEYWORDS([options mpqc set-mpqc-parameters maxiter undo])
-
-AT_CHECK([../../molecuilder -i test.conf -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/Mpqc-SetParameters/pre/test.xyz -v 1 --set-mpqc-parameters "maxiter = 499" --undo], 0, [stdout], [ignore])
-AT_CHECK([fgrep "maxiter = 499" test.in], 0, [ignore], [ignore])
-
-AT_CLEANUP
-
-
-AT_SETUP([Parser - MPQC - set maxiter with Redo])
-AT_KEYWORDS([options mpqc set-mpqc-parameters maxiter redo])
-
-AT_CHECK([../../molecuilder -i test.conf -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/Mpqc-SetParameters/pre/test.xyz -v 1 --set-mpqc-parameters "maxiter = 499" --undo --redo], 0, [stdout], [ignore])
-AT_CHECK([fgrep "maxiter = 499" test.in], 0, [ignore], [ignore])
-
-AT_CLEANUP
-
Index: sts/regression/Parser/Mpqc-SetParameters/testsuite-parser-mpqc-set-parameters-theory.at
===================================================================
--- tests/regression/Parser/Mpqc-SetParameters/testsuite-parser-mpqc-set-parameters-theory.at	(revision 07a47e0c167bba50906b5cc3e9289ec6e7f1c6db)
+++ 	(revision )
@@ -1,29 +1,0 @@
-### MPQC basis
-
-AT_SETUP([Parser - MPQC - set theory])
-AT_KEYWORDS([options mpqc set-mpqc-parameters theory])
-
-AT_CHECK([../../molecuilder -i test.in -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/Mpqc-SetParameters/pre/test.xyz -v 1 --set-mpqc-parameters "theory=CLKS"], 0, [stdout], [ignore])
-AT_CHECK([fgrep "mole<CLKS>" test.in], 0, [ignore], [ignore])
-
-AT_CLEANUP
-
-
-AT_SETUP([Parser - MPQC - set theory with Undo])
-AT_KEYWORDS([options mpqc set-mpqc-parameters theory undo])
-
-AT_CHECK([../../molecuilder -i test.in -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/Mpqc-SetParameters/pre/test.xyz -v 1 --set-mpqc-parameters "theory=CLKS" --undo], 0, [stdout], [ignore])
-AT_CHECK([fgrep "reference<CLHF>" test.in], 0, [ignore], [ignore])
-AT_CHECK([fgrep "mole<MBPT2>" test.in], 0, [ignore], [ignore])
-
-AT_CLEANUP
-
-
-AT_SETUP([Parser - MPQC - set theory with Redo])
-AT_KEYWORDS([options mpqc set-mpqc-parameters theory redo])
-
-AT_CHECK([../../molecuilder -i test.in -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/Mpqc-SetParameters/pre/test.xyz -v 1 --set-mpqc-parameters "theory=CLKS" --undo --redo], 0, [stdout], [ignore])
-AT_CHECK([fgrep "mole<CLKS>" test.in], 0, [ignore], [ignore])
-
-AT_CLEANUP
-
Index: sts/regression/Parser/Mpqc-SetParameters/testsuite-parser-mpqc-set-parameters.at
===================================================================
--- tests/regression/Parser/Mpqc-SetParameters/testsuite-parser-mpqc-set-parameters.at	(revision 07a47e0c167bba50906b5cc3e9289ec6e7f1c6db)
+++ 	(revision )
@@ -1,28 +1,0 @@
-### MPQC basis
-
-AT_SETUP([Parser - MPQC - check in file])
-AT_KEYWORDS([options mpqc set-mpqc-parameters basis maxiter theory])
-
-AT_CHECK([../../molecuilder -i ${abs_top_srcdir}/tests/regression/Parser/Mpqc-SetParameters/pre/testCLHF.in -v 1 --set-mpqc-parameters "basis = 4-31G;maxiter=499;theory=CLKS;"], 0, [stdout], [ignore])
-AT_CHECK([file=testCLHF.in; diff -I '%.*' $file ${abs_top_srcdir}/tests/regression/Parser/Mpqc-SetParameters/post/testCLHF.in], 0, [ignore], [ignore])
-
-AT_CLEANUP
-
-
-AT_SETUP([Parser - MPQC - check in file with Undo])
-AT_XFAIL_IF([/bin/true])
-AT_KEYWORDS([options mpqc set-mpqc-parameters basis maxiter theory undo])
-
-AT_CHECK([../../molecuilder -i ${abs_top_srcdir}/tests/regression/Parser/Mpqc-SetParameters/pre/testCLHF.in -v 1 --set-mpqc-parameters "basis = 4-31G;maxiter=499;theory=CLKS;" --undo], 0, [stdout], [ignore])
-AT_CHECK([file=testCLHF.in; diff -I '%.*' $file ${abs_top_srcdir}/tests/regression/Parser/Mpqc-SetParameters/post/testCLHF.in], 0, [ignore], [ignore])
-
-AT_CLEANUP
-
-
-AT_SETUP([Parser - MPQC - check in file with Redo])
-AT_KEYWORDS([options mpqc set-mpqc-parameters basis maxiter theory redo])
-
-AT_CHECK([../../molecuilder -i ${abs_top_srcdir}/tests/regression/Parser/Mpqc-SetParameters/pre/testCLHF.in -v 1 --set-mpqc-parameters "basis = 4-31G;maxiter=499;theory=CLKS;" --undo --redo], 0, [stdout], [ignore])
-AT_CHECK([file=testCLHF.in; diff -I '%.*' $file ${abs_top_srcdir}/tests/regression/Parser/Mpqc-SetParameters/post/testCLHF.in], 0, [ignore], [ignore])
-
-AT_CLEANUP
Index: tests/regression/Parser/SetParameters/Mpqc/post/testCLHF.in
===================================================================
--- tests/regression/Parser/SetParameters/Mpqc/post/testCLHF.in	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
+++ tests/regression/Parser/SetParameters/Mpqc/post/testCLHF.in	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
@@ -0,0 +1,23 @@
+mpqc: (
+	savestate = no
+	do_gradient = yes
+	mole<CLKS>: (
+		functional<StdDenFunctional>:(name=B3LYP)
+		molecule = $:molecule
+		basis = $:basis
+		maxiter = 499
+		memory = 16000000
+	)
+)
+molecule<Molecule>: (
+	unit = angstrom
+	{ atoms geometry } = {
+		O [ -0.505735	0	0 ]
+		H [ 0.252867	0	0.504284 ]
+		H [ 0.252867	0	-0.504284 ]
+	}
+)
+basis<GaussianBasisSet>: (
+	name = "4-31G"
+	molecule = $:molecule
+)
Index: tests/regression/Parser/SetParameters/Mpqc/pre/test.xyz
===================================================================
--- tests/regression/Parser/SetParameters/Mpqc/pre/test.xyz	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
+++ tests/regression/Parser/SetParameters/Mpqc/pre/test.xyz	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
@@ -0,0 +1,3 @@
+1
+	Created by molecuilder on Tue Oct  6 18:34:23 2009
+H	10	10	10
Index: tests/regression/Parser/SetParameters/Mpqc/pre/testCLHF.in
===================================================================
--- tests/regression/Parser/SetParameters/Mpqc/pre/testCLHF.in	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
+++ tests/regression/Parser/SetParameters/Mpqc/pre/testCLHF.in	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
@@ -0,0 +1,22 @@
+mpqc: (
+	savestate = no
+	do_gradient = yes
+	mole<CLHF>: (
+		molecule = $:molecule
+		basis = $:basis
+		maxiter = 1000
+		memory = 16000000
+	)
+)
+molecule<Molecule>: (
+	unit = angstrom
+	{ atoms geometry } = {
+		O [ -0.505735	0	0 ]
+		H [ 0.252867	0	0.504284 ]
+		H [ 0.252867	0	-0.504284 ]
+	}
+)
+basis<GaussianBasisSet>: (
+	name = "3-21G"
+	molecule = $:molecule
+)
Index: tests/regression/Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc-basis.at
===================================================================
--- tests/regression/Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc-basis.at	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
+++ tests/regression/Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc-basis.at	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
@@ -0,0 +1,28 @@
+### MPQC basis
+
+AT_SETUP([Parser - MPQC - set basis])
+AT_KEYWORDS([options mpqc set-mpqc-parameters basis])
+
+AT_CHECK([../../molecuilder -i test.conf -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/pre/test.xyz -v 1 --set-parser-parameters "mpqc" --parser-parameters "basis = 4-31G"], 0, [stdout], [ignore])
+AT_CHECK([fgrep "name = \"4-31G\"" test.in], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Parser - MPQC - set basis with Undo])
+AT_XFAIL_IF([/bin/true])
+AT_KEYWORDS([options mpqc set-mpqc-parameters basis undo])
+
+AT_CHECK([../../molecuilder -i test.conf -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/pre/test.xyz -v 1 --set-parser-parameters "mpqc" --parser-parameters "basis = 4-31G" --undo], 0, [stdout], [ignore])
+AT_CHECK([fgrep "name = \"4-31G\"" test.in], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Parser - MPQC - set basis with Redo])
+AT_KEYWORDS([options mpqc set-mpqc-parameters basis redo])
+
+AT_CHECK([../../molecuilder -i test.conf -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/pre/test.xyz -v 1 --set-parser-parameters "mpqc" --parser-parameters "basis = 4-31G" --undo --redo], 0, [stdout], [ignore])
+AT_CHECK([fgrep "name = \"4-31G\"" test.in], 0, [ignore], [ignore])
+
+AT_CLEANUP
Index: tests/regression/Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc-maxiterations.at
===================================================================
--- tests/regression/Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc-maxiterations.at	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
+++ tests/regression/Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc-maxiterations.at	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
@@ -0,0 +1,29 @@
+### MPQC basis
+
+AT_SETUP([Parser - MPQC - set maxiter])
+AT_KEYWORDS([options mpqc set-mpqc-parameters maxiter])
+
+AT_CHECK([../../molecuilder -i test.conf -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/pre/test.xyz -v 1 --set-parser-parameters "mpqc" --parser-parameters "maxiter = 499"], 0, [stdout], [ignore])
+AT_CHECK([fgrep "maxiter = 499" test.in], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Parser - MPQC - set maxiter with Undo])
+AT_XFAIL_IF([/bin/true])
+AT_KEYWORDS([options mpqc set-mpqc-parameters maxiter undo])
+
+AT_CHECK([../../molecuilder -i test.conf -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/pre/test.xyz -v 1 --set-parser-parameters "mpqc" --parser-parameters "maxiter = 499" --undo], 0, [stdout], [ignore])
+AT_CHECK([fgrep "maxiter = 499" test.in], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Parser - MPQC - set maxiter with Redo])
+AT_KEYWORDS([options mpqc set-mpqc-parameters maxiter redo])
+
+AT_CHECK([../../molecuilder -i test.conf -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/pre/test.xyz -v 1 --set-parser-parameters "mpqc" --parser-parameters "maxiter = 499" --undo --redo], 0, [stdout], [ignore])
+AT_CHECK([fgrep "maxiter = 499" test.in], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
Index: tests/regression/Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc-theory.at
===================================================================
--- tests/regression/Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc-theory.at	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
+++ tests/regression/Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc-theory.at	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
@@ -0,0 +1,29 @@
+### MPQC basis
+
+AT_SETUP([Parser - MPQC - set theory])
+AT_KEYWORDS([options mpqc set-mpqc-parameters theory])
+
+AT_CHECK([../../molecuilder -i test.in -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/pre/test.xyz -v 1 --set-parser-parameters "mpqc" --parser-parameters "theory=CLKS"], 0, [stdout], [ignore])
+AT_CHECK([fgrep "mole<CLKS>" test.in], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Parser - MPQC - set theory with Undo])
+AT_KEYWORDS([options mpqc set-mpqc-parameters theory undo])
+
+AT_CHECK([../../molecuilder -i test.in -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/pre/test.xyz -v 1 --set-parser-parameters "mpqc" --parser-parameters "theory=CLKS" --undo], 0, [stdout], [ignore])
+AT_CHECK([fgrep "reference<CLHF>" test.in], 0, [ignore], [ignore])
+AT_CHECK([fgrep "mole<MBPT2>" test.in], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Parser - MPQC - set theory with Redo])
+AT_KEYWORDS([options mpqc set-mpqc-parameters theory redo])
+
+AT_CHECK([../../molecuilder -i test.in -o mpqc -l ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/pre/test.xyz -v 1 --set-parser-parameters "mpqc" --parser-parameters "theory=CLKS" --undo --redo], 0, [stdout], [ignore])
+AT_CHECK([fgrep "mole<CLKS>" test.in], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
Index: tests/regression/Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc.at
===================================================================
--- tests/regression/Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc.at	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
+++ tests/regression/Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc.at	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
@@ -0,0 +1,28 @@
+### MPQC basis
+
+AT_SETUP([Parser - MPQC - check in file])
+AT_KEYWORDS([options mpqc set-mpqc-parameters basis maxiter theory])
+
+AT_CHECK([../../molecuilder -i ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/pre/testCLHF.in -v 1 --set-parser-parameters "mpqc" --parser-parameters "basis = 4-31G;maxiter=499;theory=CLKS;"], 0, [stdout], [ignore])
+AT_CHECK([file=testCLHF.in; diff -I '%.*' $file ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/post/testCLHF.in], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Parser - MPQC - check in file with Undo])
+AT_XFAIL_IF([/bin/true])
+AT_KEYWORDS([options mpqc set-mpqc-parameters basis maxiter theory undo])
+
+AT_CHECK([../../molecuilder -i ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/pre/testCLHF.in -v 1 --set-parser-parameters "mpqc" --parser-parameters "basis = 4-31G;maxiter=499;theory=CLKS;" --undo], 0, [stdout], [ignore])
+AT_CHECK([file=testCLHF.in; diff -I '%.*' $file ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/post/testCLHF.in], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Parser - MPQC - check in file with Redo])
+AT_KEYWORDS([options mpqc set-mpqc-parameters basis maxiter theory redo])
+
+AT_CHECK([../../molecuilder -i ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/pre/testCLHF.in -v 1 --set-parser-parameters "mpqc" --parser-parameters "basis = 4-31G;maxiter=499;theory=CLKS;" --undo --redo], 0, [stdout], [ignore])
+AT_CHECK([file=testCLHF.in; diff -I '%.*' $file ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Mpqc/post/testCLHF.in], 0, [ignore], [ignore])
+
+AT_CLEANUP
Index: tests/regression/Parser/SetParameters/Psi3/pre/test.xyz
===================================================================
--- tests/regression/Parser/SetParameters/Psi3/pre/test.xyz	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
+++ tests/regression/Parser/SetParameters/Psi3/pre/test.xyz	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
@@ -0,0 +1,3 @@
+1
+	Created by molecuilder on Tue Oct  6 18:34:23 2009
+H	10	10	10
Index: tests/regression/Parser/SetParameters/Psi3/testsuite-parser-set-parameters-psi3-wavefunction.at
===================================================================
--- tests/regression/Parser/SetParameters/Psi3/testsuite-parser-set-parameters-psi3-wavefunction.at	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
+++ tests/regression/Parser/SetParameters/Psi3/testsuite-parser-set-parameters-psi3-wavefunction.at	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
@@ -0,0 +1,28 @@
+### PSI3 basis
+
+AT_SETUP([Parser - PSI3 - set wavefunction])
+AT_KEYWORDS([options psi3 set-psi3-parameters wavefunction])
+
+AT_CHECK([../../molecuilder -i test.psi -o psi3 -l ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Psi3/pre/test.xyz -v 1 --set-parser-parameters "psi3" --parser-parameters "wfn=mp2"], 0, [stdout], [ignore])
+AT_CHECK([grep "wfn.*mp2" test.psi], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Parser - PSI3 - set wavefunction with Undo])
+AT_KEYWORDS([options psi3 set-psi3-parameters wavefunction undo])
+
+AT_CHECK([../../molecuilder -i test.psi -o psi3 -l ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Psi3/pre/test.xyz -v 1 --set-parser-parameters "psi3" --parser-parameters "wfn=mp2" --undo], 0, [stdout], [ignore])
+AT_CHECK([grep "wfn.*scf" test.psi], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Parser - PSI3 - set wavefunction with Redo])
+AT_KEYWORDS([options psi3 set-psi3-parameters theory redo])
+
+AT_CHECK([../../molecuilder -i test.psi -o psi3 -l ${abs_top_srcdir}/tests/regression/Parser/SetParameters/Psi3/pre/test.xyz -v 1 --set-parser-parameters "psi3" --parser-parameters "wfn=mp2" --undo --redo], 0, [stdout], [ignore])
+AT_CHECK([grep "wfn.*mp2" test.psi], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
Index: tests/regression/Parser/testsuite-parser.at
===================================================================
--- tests/regression/Parser/testsuite-parser.at	(revision 07a47e0c167bba50906b5cc3e9289ec6e7f1c6db)
+++ tests/regression/Parser/testsuite-parser.at	(revision 41d023ff8dc20a2b26d06e7c4960972918c6e500)
@@ -1,9 +1,4 @@
 AT_BANNER([MoleCuilder - Parser])
 
-# set MPQC basis, theory and maxiter
-m4_include([Parser/Mpqc-SetParameters/testsuite-parser-mpqc-set-parameters.at])
-m4_include([Parser/Mpqc-SetParameters/testsuite-parser-mpqc-set-parameters-basis.at])
-m4_include([Parser/Mpqc-SetParameters/testsuite-parser-mpqc-set-parameters-maxiterations.at])
-m4_include([Parser/Mpqc-SetParameters/testsuite-parser-mpqc-set-parameters-theory.at])
 
 # parsing mpqc
@@ -11,4 +6,10 @@
 m4_include([Parser/Mpqc/testsuite-parser-mpqc-load.at])
 m4_include([Parser/Mpqc/testsuite-parser-mpqc-save.at])
+
+# set mpqc basis, theory and maxiter
+m4_include([Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc.at])
+m4_include([Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc-basis.at])
+m4_include([Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc-maxiterations.at])
+m4_include([Parser/SetParameters/Mpqc/testsuite-parser-set-parameters-mpqc-theory.at])
 
 # parsing pcp
@@ -24,4 +25,7 @@
 m4_include([Parser/Pdb/testsuite-parser-pdb-save.at])
 m4_include([Parser/Pdb/testsuite-parser-pdb-with-conects.at])
+
+# set psi3 wavefunction
+m4_include([Parser/SetParameters/Psi3/testsuite-parser-set-parameters-psi3-wavefunction.at])
 
 # bugfix checks
